var FlashInfo = cc.Class.extend({
	path : null,
	time : 2,
	fadeInTime : 1,
	fadeOutTime : 1,
	ctor : function(path, time, fadeInTime, fadeOutTime) {
		this.path = path;
		this.time = time;
		this.fadeInTime = fadeInTime;
		this.fadeOutTime = fadeOutTime;
	}
},"FlashInfo");

var UpdateView = cc.Layer.extend({

	_blackBg:null,
	_bg:null,
	// _gameLogo:null,
	_tipLabel:null,
    _barBg:null,
    _bar:null,
    _barLight:null,
	// scene : null,
    gameConfig : null,
    startGameCall : null,
    startGameCallTarget : null,

	flashes : null,
	flashInfo : null,
	flashImg : null,
	flashIdx : 0,

	_platform : "wins/", 
	_isWin : false,
	formatPath : function(path) {
		// if(path.indexOf("res") > -1) {
		// 	path = path.replace("res/", "res/" + this._platform);
		// }
		// if(!this._isWin) {
		// 	path = path.repalce(".png", ".pvr.ccz").replace(".jpg", ".pvr.ccz");
		// }
		return path;
	},

	ctor:function(gameConfig, callback, target)
	{
		cc.Layer.prototype.ctor.call(this);
		// this.scene = scene;
		this.gameConfig = gameConfig; 
		this.startGameCall = callback;
		this.startGameCallTarget = target;

		if(this.gameConfig.isAndroid()) {
			this._platform = "android/";
		}
		else if(this.gameConfig.isIOS()) {
			this._platform = "ios/";
		}

		var outPicPath = "outPic";
		if(gameConfig.isAndroid()) {
			outPicPath = "outPicandroid";
		}
		else if(gameConfig.isIOS()) {
			outPicPath = "outPicios";
		}
		this._isWin = !(this.gameConfig.isAndroid() && this.gameConfig.isIOS());

		var offsetX = (cc.winSize.width - this.getContentSize().width) / 2;

		//普通显示
		this._blackBg = ccui.ImageView.create();
		this._blackBg.loadTexture(this.formatPath("res/GameUI/" + outPicPath + "/ui_blackBoard.png"));
		this._blackBg.retain();
		this._blackBg.setScale9Enabled(true);
		this._blackBg.setCapInsets(cc.rect(4,4,2,2));
		this._blackBg.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2));
		this._blackBg.setSize(cc.size(cc.winSize.width,cc.winSize.height));
		this._blackBg.setTouchEnabled(true);
		this._bg = ccui.ImageView.create();
		this._bg.retain();
		this._bg.loadTexture(this.formatPath("res/GameUI/" + outPicPath + "/loadingBg0.jpg"));
		this._bg.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2));
		// this._gameLogo = ccui.ImageView.create();
		// this._gameLogo.retain();
		// this._gameLogo.loadTexture(this.formatPath("res/GameUI/" + outPicPath + "/ui_gameLogo.png"));
		// this._gameLogo.setPosition(cc.p(1111, 615));
        this._tipLabel = new cc.LabelTTF("","",22);
        this._tipLabel.retain();
        this._tipLabel.setFontFillColor(cc.color(255, 255, 255));
        this._tipLabel.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2 - 328.5));
        this._tipLabel.enableShadow(cc.color(0,0,0,1),cc.size(1,-1),0);
        this._barBg = ccui.ImageView.create();
        this._barBg.retain();
        this._barBg.loadTexture(this.formatPath("res/GameUI/" + outPicPath + "/ui_readingBarBg.png"));
        this._barBg.setPosition(cc.p(cc.winSize.width / 2 + 3,cc.winSize.height / 2 - 287.5));


        this._barLight = ccui.ImageView.create();
        this._barLight.retain();
        this._barLight.loadTexture(this.formatPath("res/GameUI/" + outPicPath + "/ui_readingBar_lightPoint.png"));

        this._bar = ccui.LoadingBar.create();
        this._bar.retain();
        this._bar.loadTexture(this.formatPath("res/GameUI/" + outPicPath + "/ui_readingBar.png"));
        // this._bar.setScale9Enabled(true);
        // this._bar.setCapInsets(cc.rect(501,6,1,1));
        this._bar.setSize(cc.size(1003,13));
        this._bar.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2 - 287.5));
        this._bar.setPercent(0);
        this._bar.addChild(this._barLight);
        this._barLight.setPosition(cc.p(0,7));

		//闪屏显示
		var srcList = this.gameConfig.flashes;
		this.flashes = [];
		for(var i = 0; i < srcList.length; i++) {
			this.flashes.push(new FlashInfo(srcList[i], 2, 1, 1));
		}
		print("#this.flashes", this.flashes.length);
		if(this.flashes.length == 0) {
			this.completeFlash();
		}
		else {
			this.showFlash();
		}
 
		this.retain();
	}, 
	setProgress : function(progress)
	{
		// print("#progress", progress);
		this._barLight.setPositionX((this._bar.getContentSize().width * progress)/100);
        this._bar.setPercent(progress);
	},
	setTips:function(value)
	{ 
		this._tipLabel.setString(value); 
	},

	completeFlash : function() {
		print("#completeFlashcompleteFlashcompleteFlash");
		this.addChild(this._blackBg);
		this.addChild(this._bg);
		// this.addChild(this._gameLogo);
		this.addChild(this._tipLabel);
        this.addChild(this._barBg);
        this.addChild(this._bar);
		// this.scene.startGame();
        if(!!this.startGameCall) {
            this.startGameCall.call(this.startGameCallTarget);
        }
	},
	showFlash : function() {
		var this_ = this; 
		if(!!this.flashInfo) {
			this.removeChild(this.flashImg);
			this.flashImg.stopAllActions();
			this.flashImg.release();
			this.flashImg = null;
			this.flashInfo = null;
		} 
		if(this.flashes.length <= this.flashIdx) { 
			this.completeFlash();
		}
		else { 
			var size = cc.winSize;
			this.flashInfo = this.flashes[this.flashIdx];
			this.flashIdx++;
			if(!!this.flashInfo && jsb.fileUtils.isFileExist(this.flashInfo.path)) {
				this.flashImg = new cc.Sprite(this.flashInfo.path);
				if(!!this.flashImg) {
					var actionOut = cc.fadeOut(this.flashInfo.fadeOutTime), //淡出
						actionIn = cc.fadeIn(this.flashInfo.fadeInTime), // 渐入
						action = cc.rotateBy(this.flashInfo.time,0), // 旋转
						callback = cc.callFunc(function() {
							this_.showFlash(); 
						}),
						anima = cc.sequence(actionIn, action, actionOut, callback);

					this.flashImg.setOpacity(0);
					this.flashImg.retain();
					this.flashImg.setAnchorPoint(cc.p(.5,.5));
					this.flashImg.setPosition(size.width / 2, size.height / 2);
					this.addChild(this.flashImg);
					this.flashImg.runAction(anima);
				}
				else {
					this.flashInfo = null;
					this.showFlash();
				}

			}
			else {
				this.completeFlash();
			}
		}
	},

	dispose:function()
	{ 
		if(this._tipLabel != null)
		{
			this._tipLabel.release();
			this._tipLabel = null;
		}
		if(this._bg != null)
		{
			this._bg.release();
			this._bg = null;
		}
		// if(this._gameLogo != null)
		// {
		// 	this._gameLogo.release();
		// 	this._gameLogo = null;
		// }
        if(this._barBg != null)
        {
            this._barBg.release();
            this._barBg = null;
        }
        if(this._bar != null)
        {
            this._bar.release();
            this._bar = null;
        }
        if(this._barLight != null)
        {
            this._barLight.release();
            this._barLight = null;
        }
        if(this._blackBg != null)
        {
            this._blackBg.release();
            this._blackBg = null;
        }
		if(this.getParent() != null)
		{
			this.removeFromParent(true);
		}
		this.release();
	}
},"UpdateView")